% Copyright 2016, Contributors to Ultimate Drill Cards 2016
% Made available under the Creative Commons Attribution-ShareAlike 4.0
% International Public License
%
% See the file LICENSE for the full text of the license.

\ProvidesPackage{drills}

\RequirePackage{fontspec}

\RequirePackage{ccicons}

\RequirePackage{environ}

\makeatletter
\newsavebox{\measure@tikzpicture}
\NewEnviron{drillGraphic}[1][\linewidth]{%
  \def\tikz@width{#1}%
  \def\drillGraphicScale{1}\begin{lrbox}{\measure@tikzpicture}%
  \begin{tikzpicture}[scale=\drillGraphicScale, thick]
  \BODY
  \end{tikzpicture}
  \end{lrbox}%
  \pgfmathparse{#1/\wd\measure@tikzpicture}%
  \edef\drillGraphicScale{\pgfmathresult}%
  \begin{center}
  \begin{tikzpicture}[scale=\drillGraphicScale, thick]
  \BODY
  \end{tikzpicture}
  \end{center}
}
\makeatother

% Needs to be loaded before fancyhdr
\RequirePackage[left=2cm,right=2cm,top=2cm,bottom=2cm]{geometry}

\RequirePackage{fancyhdr}

\pagestyle{fancy}
\renewcommand{\headrulewidth}{0pt}

\RequirePackage{multicol}

\RequirePackage{tikz}
\usetikzlibrary{calc,arrows}
\tikzset{ >=stealth',} % Latex Arrows

\newcommand{\drillsTikzPic}[1]{
  \begin{tikzpicture}
    \draw (0,0) pic {#1};
  \end{tikzpicture}
}

\tikzset{
  cone/.pic={\draw[thick] (-0.1,0.01) arc (-170:-10:0.1 and 0.025);\draw[thick] (-0.1,0) -- (0,0.2) -- (0.1,0);},
  playerDisc/.pic={\draw[thick] (0,0) circle (0.1); \draw[thick] (0,0) circle (0.05);},
  player/.pic={\draw[thick] (0,0) circle (0.1);},
  defender/.pic={\fill (0,0) circle (0.1);}
}

\RequirePackage[explicit]{titlesec}

\RequirePackage{translations}

\DeclareTranslationFallback {drills-persons}{Persons}
\DeclareTranslation{English}{drills-persons}{Persons}
\DeclareTranslation{German} {drills-persons}{Personen}

\DeclareTranslationFallback {drills-at-least}{at least}
\DeclareTranslation{English}{drills-at-least}{at least}
\DeclareTranslation{German} {drills-at-least}{mindestens}

\DeclareTranslationFallback {drills-split-with}{split with}
\DeclareTranslation{English}{drills-split-with}{split with}
\DeclareTranslation{German} {drills-split-with}{teilen ab}


\DeclareTranslationFallback {drills-keywords}{Keywords}
\DeclareTranslation{English}{drills-keywords}{Keywords}
\DeclareTranslation{German} {drills-keywords}{Schlüsselwörter}

\DeclareTranslationFallback {drills-drill}{Drill}
\DeclareTranslation{English}{drills-drill}{Drill}
\DeclareTranslation{German} {drills-drill}{Übung}

\DeclareTranslationFallback {drills-material}{Material}
\DeclareTranslation{English}{drills-material}{Material}
\DeclareTranslation{German} {drills-material}{Material}

\DeclareTranslationFallback {drills-setup}{Setup}
\DeclareTranslation{English}{drills-setup}{Setup}
\DeclareTranslation{German} {drills-setup}{Aufbau}

\DeclareTranslationFallback {drills-execution}{Execution}
\DeclareTranslation{English}{drills-execution}{Execution}
\DeclareTranslation{German} {drills-execution}{Durchführung}

\DeclareTranslationFallback {drills-variant}{Variant}
\DeclareTranslation{English}{drills-variant}{Variant}
\DeclareTranslation{German} {drills-variant}{Variante}

\DeclareTranslationFallback {drills-cone}{Cone}
\DeclareTranslation{English}{drills-cone}{Cone}
\DeclareTranslation{German} {drills-cone}{Hütchen}

\DeclareTranslationFallback {drills-cones}{Cones}
\DeclareTranslation{English}{drills-cones}{Cones}
\DeclareTranslation{German} {drills-cones}{Hütchen}

\DeclareTranslationFallback {drills-discs}{Discs}
\DeclareTranslation{English}{drills-discs}{Discs}
\DeclareTranslation{German} {drills-discs}{Scheiben}

\DeclareTranslationFallback {drills-key}{Key}
\DeclareTranslation{English}{drills-key}{Key}
\DeclareTranslation{German} {drills-key}{Legende}

\DeclareTranslationFallback {drills-player}{Player}
\DeclareTranslation{English}{drills-player}{Player}
\DeclareTranslation{German} {drills-player}{Spieler}

\DeclareTranslationFallback {drills-defender}{Defender}
\DeclareTranslation{English}{drills-defender}{Defender}
\DeclareTranslation{German} {drills-defender}{Verteidiger}

\DeclareTranslationFallback {drills-player-with-disc}{Player with disc}
\DeclareTranslation{English}{drills-player-with-disc}{Player with disc}
\DeclareTranslation{German} {drills-player-with-disc}{Spieler mit der Scheibe}

\newcommand*\drillName[1]{\section*{#1}}
\newcommand*\drillPersons[2]{\GetTranslation{drills-persons}: \GetTranslation{drills-at-least} #1, \GetTranslation{drills-split-with} #2}
\newcommand\drillKeywords[1]{\textit{\GetTranslation{drills-keywords}: #1}}
\newcommand\drillCones[1]{\item{#1 \GetTranslation{drills-cones}}}
\newcommand\drillDiscs[1]{\item{#1 \GetTranslation{drills-discs}}}

\newcommand\drillNumberedPlayerSymbol[1]{
  \kern-1.5ex\begin{tikzpicture}[baseline=-3pt]
    \node[thick] {\drillsTikzPic{player}};
    \node {\bf\tiny #1};
  \end{tikzpicture}\kern-0.3ex
}

\newcommand\drillPlayerWithDiscSymbol{
  \kern-1.5ex\begin{tikzpicture}[baseline=-3pt]
    \node[thick] {\drillsTikzPic{playerDisc}};
  \end{tikzpicture}\kern-0.3ex
}

\newcommand\drillDefenderSymbol{
  \kern-1.5ex\begin{tikzpicture}[baseline=-3pt]
    \node[thick] {\drillsTikzPic{defender}};
  \end{tikzpicture}\kern-0.3ex
}

% Parameters: Number, Name, Persons, Keywords
\newenvironment{drillCard}[5]{
  \lfoot{\GetTranslation{drills-key}:
    \tikz[baseline=-3pt] \node[thick] {\drillsTikzPic{cone}}; \GetTranslation{drills-cone},
    \tikz[baseline=-3pt] \node[thick] {\drillsTikzPic{player}}; \GetTranslation{drills-player},
    \tikz[baseline=-3pt] \node[thick] {\drillsTikzPic{defender}}; \GetTranslation{drills-defender},
    \tikz[baseline=-3pt] \node[thick] {\drillsTikzPic{playerDisc}}; \GetTranslation{drills-player-with-disc}\\
    \tiny \textcopyright\ Contributors to Ultimate Drill Cards 2016, Made available under the Creative Commons Attribution-ShareAlike 4.0 International Public License
  }
  \cfoot{}
  \rfoot{
    \ \\
    \tiny \raisebox{-2\depth}{\ccbysa}
  }
  \rhead{\GetTranslation{drills-drill} #1}

  \begin{multicols*}{2}[
    \drillName{#2}
    \drillPersons{#3}{#4}\\
    \drillKeywords{#5}
  ]
}{
  \end{multicols*}
  \newpage
}

\newenvironment{drillMaterial}{
\subsection*{\GetTranslation{drills-material}}
\begin{itemize}
\setlength\itemsep{0em}
}{
\end{itemize}
}

\newenvironment{drillSetup}{
  \subsection*{\GetTranslation{drills-setup}}
}{
}

\newenvironment{drillExecution}{
  \subsection*{\GetTranslation{drills-execution}}
}{
}


\renewcommand\thesubsubsection{\arabic{subsubsection}}
\titleformat{\subsubsection}{\bfseries}{}{0pt}{#1\ \thesubsubsection}

\newenvironment{drillVariant}[1]{
  \subsubsection{\GetTranslation{drills-variant}}\label{#1}
}{
}

\newcommand*\drillRefVariant[1]{\GetTranslation{drills-variant}~\ref{#1}}
